Subject: Re: bug#20707: [PROPOSED PATCH] Use curved quoting in C-generated errors

From: Alan Mackenzie <[email-masked]>
Date: Tue, 9 Jun 2015 13:34:23 +0000

Hello, Paul.

On Mon, Jun 08, 2015 at 11:53:54PM -0700, Paul Eggert wrote:
> Alan Mackenzie wrote:

> > The topic was specifically "message output".

> OK.

> > we don't control Info output

> Actually, we do control it, and can easily tell makeinfo to output straight 
> ASCII quotes.

Can we?  I've had a look at the online Texinfo-5 manual, but couldn't
find anything specifically about ASCII quotes.  The only thing remotely
relevant I saw was the --enable-encoding option, which I think is more
about the encoding in the .texi file than in the output .info.

> Although that would have made sense in 1995, it doesn't make sense now,
> as makeinfo's default behavior of outputting curved quotes works better
> for ordinary usage today.

Paul, this is vague hand-waving, and is simply untrue.  The only use case
where curly quotes might be said to "work" better is in passive viewing
of an Info file, and that only in a subset of our display environments.

For every other thing you might want to do with an Info file, ASCII
quotes are superior.

The abstract principle at work here is that ASCII quotes are
@dfn{working} characters, whereas the curly quotes are merely
@dfn{display} characters.  The working characters are on keyboards
(without awkward workarounds) and they can be displayed "anywhere".  The
display characters are great when sent to the printer, or in PDF files,
though.

> > you could fix that by fixing your fonts

> No, that would disagree with common usage for these characters.

I meant change the appearance of your 0x27 apostrophe so that its
appearance as a quote mark doesn't jar your aesthetic sensibilities.
This has nothing to do with its usage, surely?

> Almost everybody uses the current standard in this area, and it
> wouldn't be reasonable to require users to switch to long-obsolete font
> styles just to see decent output.

What standard?  What other projects do is their thing, and shouldn't be
affecting Emacs.  Emacs is different from most of them, in that its users
manipulate its outputs.  Anyhow, who said that the traditional form of
quoting is not decent?

> > That still displays double curly quotes as inverse question marks, though.

> This is not a problem if the topic is specifically "message output", as only 
> single quotes are being proposed for message output.  That being said, most 
> likely your problem is because you told Emacs you were in a UTF-8 locale.  You 
> can try setting LC_ALL=en_GB.iso885915 or something like that before starting Emacs.

> But I'm not sure I would do that.  If I understand the rest of your message 
> correctly, your environment already displays curved single quotes as nicely 
> curved single quotes.

Yes, the single curly quotes are "hard linked" to the ASCII single
quotes in the font.  That isn't acceptable for me - they should have
distinct glyphs if they're going to be there at all.

> The main problem for message output is that you don't like the exact
> appearance of curved single quotes in your font and would prefer a
> different appearance and don't like any of the other fonts I've
> suggested and would rather fire up a font editor to get an appearance
> you like.  Although that's all fine of course, this appears to be
> mainly an issue of font style preference, which means it's an issue
> that does not block the proposed change.

This is not the case; the discussion of individual fonts, and my personal
setup, and so on were just a distraction from the main points.  I've
described in some detail many of the things I don't like about the
proposed change, and few of them are to do with the minutiae of the
available fonts.  The change is not intended to be optional, I think,
because that would be difficult to implement.

So, it's going to be a pain in the posterior for most, if not all, users
of Emacs on terminals, and the benefit for users in GUI environments
seems marginal.  I am against this change being made.

-- 
Alan Mackenzie (Nuremberg, Germany).